/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.ImageIcon;
import javax.swing.JTabbedPane;



public class PanelPestanas  extends JTabbedPane{

	//Declaramos los atributos de la clase
	
	private static final long serialVersionUID = 1L;
	
	//Pestaas
	
	PestanaBusqueda pestana1 = null;
	PestanaDiccionarios pestana2 = null;
	PestanaConfig pestana3 = null;
	PestanaWiki pestana4 = null;
	PestanaAcercaDe pestana5 = null;
	
	
		
	
	public PanelPestanas() {
		
		this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
		this.setPreferredSize(new Dimension(97, 160));
		this.setFont(new Font("Dialog", Font.PLAIN, 12));
		
		
		//Aado las Pestanas 
		
		getPestanas();
	
	}
	
	private void  getPestanas(){
		
		
		//Creo las Pestanas
		pestana1 = new PestanaBusqueda();
		pestana2 = new PestanaDiccionarios();
		pestana3 = new PestanaConfig();
		pestana4 = new PestanaWiki();
		pestana5 = new PestanaAcercaDe();
		
		
		//Las aado al Panel de Pestaas
		
		this.addTab(null, new ImageIcon("imagenes/search.png") , pestana1 , Configuracion.messages.getString("etiqueta1"));
		this.addTab(null, new ImageIcon("imagenes/diccionarios.png"), pestana2, Configuracion.messages.getString("etiqueta2"));
		this.addTab(null, new ImageIcon("imagenes/configuracion.png"), pestana3, Configuracion.messages.getString("etiqueta3"));
		this.addTab(null, new ImageIcon("imagenes/colaborativo.png"), pestana4, Configuracion.messages.getString("etiqueta4"));
		this.addTab(null, new ImageIcon("imagenes/ayuda.png"), pestana5, Configuracion.messages.getString("etiqueta5"));
		
	}
	
	public void cambiarColorInterfaz(){
		this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
		pestana1.cambiarColorInterfaz();
		pestana2.cambiarColorInterfaz();
		pestana3.cambiarColorInterfaz();
		pestana4.cambiarColorInterfaz();
		pestana5.cambiarColorInterfaz();
	
	}
	
	public void cambiarIdiomaInterfaz(){
		
		//Cambiamos el nombre de las pestaas
		this.setToolTipTextAt(0, Configuracion.messages.getString("etiqueta1"));
		this.setToolTipTextAt(1, Configuracion.messages.getString("etiqueta2"));
		this.setToolTipTextAt(2, Configuracion.messages.getString("etiqueta3"));
		this.setToolTipTextAt(3, Configuracion.messages.getString("etiqueta4"));
		this.setToolTipTextAt(4, Configuracion.messages.getString("etiqueta5"));
		
		//Cambiamos el contenido de las distintas pestaas
		pestana1.cambiarIdiomaInterfaz();
		pestana2.cambiarIdiomaInterfaz();
		pestana3.cambiarIdiomaInterfaz();
		pestana4.cambiarIdiomaInterfaz();
		pestana5.cambiarIdiomaInterfaz();
	
	}

}