/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;



public class PestanaConfig extends JPanel{
		
	
	Etiqueta etiquetaColorPrim= null;
	Etiqueta etiquetaColorSecun= null;
	Etiqueta etiquetaColorTitulo= null;
	Etiqueta etiquetaIdioma = null;
	Etiqueta etiquetaConexion = null;
	Etiqueta etiquetaSplash = null;
	
	
	//Radios
	
	RadioButton radioButton1  = null;
	RadioButton radioButton2  = null;
	RadioButton radioButton3  = null;
	RadioButton radioButton4  = null;
	RadioButton radioButton5  = null;
	
	//Grupo de Radio
	
	 ButtonGroup grupoTeclado = null;
	 ButtonGroup grupoRaton = null;
	 
	//Barra Desplazamiento
	 
	 BarraDesplazamiento barraDesplazamiento1 = null;
	 BarraDesplazamiento barraDesplazamiento2 = null;
	 BarraDesplazamiento barraDesplazamiento3 = null;
	 BarraDesplazamiento barraDesplazamiento4 = null;
	 BarraDesplazamiento barraDesplazamiento5 = null;
	 BarraDesplazamiento barraDesplazamiento6 = null;
	 
	 //Boton
	 
	 Boton botonColor = null;
	 
	 //CajaValidar
	 

	CajaValidar cajaValidarSplash = null;
	CajaValidar cajaValidarConexion = null;
	
	//Desplegable
	
	Desplegable desplegableIdioma = null;
	
	private static final long serialVersionUID = 1L;
    

	public PestanaConfig() {
				
		//Configuro el Panel
		
		this.setLayout(null);
        this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
        this.setPreferredSize(new Dimension(97, 140));
        this.setVisible(true);

        //Aado las etiquetas
        
		getLabels();
		
		 //Aado las Radios
		
		// desabilitado por que el lanzamiento no esta todavia
		// getRadios();
		
		// Aado al panel botones y todo lo demas
		
		getDesplegable();
		
		//Aado las Barra de Desplazamiento
		
		getBarraDesplazamiento();
		
		//Aado CheckBox
		
		getCajaValidar();
		
		//Aado Boton
		
		getBoton();
	}
	
	private void getLabels(){
				
		
			etiquetaColorPrim = new Etiqueta(10, 185, 163, 22, "l_colprim" );
			etiquetaColorSecun = new Etiqueta(159, 185, 163, 22, "l_colsec" );
			etiquetaColorTitulo = new Etiqueta(10, 155, 200, 24, "l_colores");
			etiquetaIdioma = new Etiqueta(10, 15, 160, 23, "l_idioma" );
			etiquetaConexion = new Etiqueta(36, 110, 240, 16, "l_conexion" );
			etiquetaSplash = new Etiqueta(36, 65, 240, 16, "l_splash" );	 		
    		
    		//Aado los labels   		
  
    		this.add(etiquetaColorTitulo, null);
    		this.add(etiquetaColorPrim, null);
    		this.add(etiquetaColorSecun, null);
    		this.add(etiquetaConexion, null);
    		this.add(etiquetaIdioma, null);
    		this.add(etiquetaSplash,null);            
		
	}
	
	
	@SuppressWarnings("unused")
	private void getRadios(){
		
		//Creamos los grupos de radio
        
		grupoTeclado = new ButtonGroup();
		grupoRaton = new ButtonGroup();
		
		radioButton1 = new RadioButton(10, 90, 21, 21);
		radioButton2 = new RadioButton(69, 90, 21, 21);
		radioButton3 = new RadioButton(123, 90, 21, 21);
		radioButton4 = new RadioButton(199, 90, 21, 21);
		radioButton5 = new RadioButton(199, 117, 21, 21);

	
		grupoTeclado.add(radioButton1);
		grupoTeclado.add(radioButton2);
		grupoTeclado.add(radioButton3);
		grupoRaton.add(radioButton4);
		grupoRaton.add(radioButton5);
		
		this.add(radioButton1, null);
		this.add(radioButton2, null);
		this.add(radioButton3, null);
		this.add(radioButton4, null);
		this.add(radioButton5, null);
		
	}
	
	
	private void getBarraDesplazamiento(){
		
		barraDesplazamiento1 = new BarraDesplazamiento(10, 275, 130, 12, "colorprima1" );
		barraDesplazamiento2 = new BarraDesplazamiento(10, 245, 130, 12, "colorprima2" );
		barraDesplazamiento3 = new BarraDesplazamiento(10, 215, 130, 12, "colorprima3" );
		barraDesplazamiento4 = new BarraDesplazamiento(160, 275, 130, 12, "colorsecun1" );
		barraDesplazamiento5 = new BarraDesplazamiento(160, 245, 130, 12, "colorsecun2" );
		barraDesplazamiento6 = new BarraDesplazamiento(160, 215, 130, 12, "colorsecun3" );
				
		this.add(barraDesplazamiento1, null);
		this.add(barraDesplazamiento2, null);
		this.add(barraDesplazamiento3, null);
		this.add(barraDesplazamiento4, null);
		this.add(barraDesplazamiento5, null);
		this.add(barraDesplazamiento6, null);
			
	}
		
	private void getCajaValidar(){
		
		cajaValidarConexion = new CajaValidar(10, 108, 21, 21,2);
		cajaValidarSplash = new CajaValidar (10, 63, 21, 21,2);
		
		this.add(cajaValidarSplash, null);          
        this.add(cajaValidarConexion, null);
	}
		
	private void getBoton(){
		
			//Aado boton
		botonColor = new Boton(215, 157, 76, 20,"b_colororiginal",2);
		
		this.add(botonColor,null);
	}
	

	private void getDesplegable() {
		
		desplegableIdioma = new Desplegable (193, 15, 100, 23);
		this.add(desplegableIdioma , null);
		    
	}
	
	
	public void configurarEventosPestana(final Configuracion config,final  Aplicacion aplicacion){

	  
	  	//	Configuro los eventos de las barra de color
		
		
		barraDesplazamiento1.addChangeListener(new ChangeListener() {

		public void stateChanged(ChangeEvent arg0) {
			
				Configuracion.propiedades.setProperty("colorprima1", String.valueOf(barraDesplazamiento1.getValue()));
				aplicacion.cambiarColorInterfaz();
			
				// guardar configuracion 
				config.guardarconfiguracion();
		
			}
	   
		   }); 
		   
		barraDesplazamiento2.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent arg0) {

					Configuracion.propiedades.setProperty("colorprima2", String.valueOf(barraDesplazamiento2.getValue()));
					aplicacion.cambiarColorInterfaz();
					
					config.guardarconfiguracion();
			
				}
		   
			   }); 
		
		barraDesplazamiento3.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent arg0) {
					Configuracion.propiedades.setProperty("colorprima3", String.valueOf(barraDesplazamiento3.getValue()));
					aplicacion.cambiarColorInterfaz();
					
					config.guardarconfiguracion();
			
				}
		   
			   }); 
		barraDesplazamiento4.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent arg0) {
					Configuracion.propiedades.setProperty("colorsecun1", String.valueOf(barraDesplazamiento4.getValue()));
					aplicacion.cambiarColorInterfaz();
					
					config.guardarconfiguracion();
			
				}
		   
			   }); 
		barraDesplazamiento5.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent arg0) {
					Configuracion.propiedades.setProperty("colorsecun2", String.valueOf(barraDesplazamiento5.getValue()));
					aplicacion.cambiarColorInterfaz();
					
					config.guardarconfiguracion();			
			
				}
		   
			   }); 
		barraDesplazamiento6.addChangeListener(new ChangeListener() {

				public void stateChanged(ChangeEvent arg0) {
					Configuracion.propiedades.setProperty("colorsecun3", String.valueOf(barraDesplazamiento6.getValue()));
					aplicacion.cambiarColorInterfaz();
				
					config.guardarconfiguracion();
			
				}
		   
			   }); 
   
		   
		cajaValidarSplash.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					config.cambiaSplash(String.valueOf(cajaValidarSplash.isSelected()));		
				}	
		    });
		   
			desplegableIdioma.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					config.cambiaridioma(String.valueOf(desplegableIdioma.getSelectedIndex()));
					
					//cambiarIdioma(flagEstaConectado);
					
					//cambiar idoma en la interfaz

					aplicacion.cambiarIdiomaInterfaz();
					
					//cambia idioma tb en tray 
					aplicacion.creaTray();
					
				}
			});
			
			botonColor.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					Configuracion.propiedades.setProperty("colorprima1", "102");
					Configuracion.propiedades.setProperty("colorprima2", "174");
					Configuracion.propiedades.setProperty("colorprima3", "233");
					Configuracion.propiedades.setProperty("colorsecun1", "66");
					Configuracion.propiedades.setProperty("colorsecun2", "129");
					Configuracion.propiedades.setProperty("colorsecun3", "183");
					aplicacion.cambiarColorInterfaz();
					config.guardarconfiguracion();
				}
			});
			
			cajaValidarConexion.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					config.cambiaConexion(String.valueOf(cajaValidarConexion.isSelected()));
					aplicacion.accionCajaConexion();
			
									
				}	
		    });
		    	
			
  }
	//Procedimiento para cambiar el color de la aplicacion
	
	public void cambiarColorInterfaz(){
		
		this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
		botonColor.cambiarColorInterfaz();
		cajaValidarConexion.cambiarColorInterfaz();
		cajaValidarSplash.cambiarColorInterfaz();
		desplegableIdioma.cambiarColorInterfaz();
		barraDesplazamiento1.cambiarColorInterfaz();
		barraDesplazamiento2.cambiarColorInterfaz();
		barraDesplazamiento3.cambiarColorInterfaz();
		barraDesplazamiento4.cambiarColorInterfaz();
		barraDesplazamiento5.cambiarColorInterfaz();
		barraDesplazamiento6.cambiarColorInterfaz();
		
	}
	
	public void cambiarIdiomaInterfaz(){
		
		//cambiamos las etiquetas

		etiquetaColorPrim.cambiarIdiomaInterfaz();
		etiquetaColorSecun.cambiarIdiomaInterfaz();
		etiquetaColorTitulo.cambiarIdiomaInterfaz();
		etiquetaIdioma.cambiarIdiomaInterfaz();
		etiquetaConexion.cambiarIdiomaInterfaz();
		etiquetaSplash.cambiarIdiomaInterfaz();
		
		//cambiamos los botones
		botonColor.cambiarIdiomaInterfaz();
	}
	
}	

	


