/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.awt.Dimension;
import java.awt.Font;
import java.awt.SystemColor;
import java.awt.Toolkit;
import javax.swing.JFrame;


public class Ventana extends JFrame {
	
	private static final long serialVersionUID = 1L;

	//Variables
	
	PanelInicial panelInicial = null;
	Boolean booClipboard = false; 
	

	/**
	 * El Metodo Constructor
	 */
	public Ventana() {
			super();
			initialize();
	}
	
	/**
	 * Inicializo la Ventana
	 *
	 */
	
	public void initialize() {
			
		//Configuro los eventos de la ventana
		
		eventosSO();
		
		//Configuro la Ventana
	
		setParametros();
		
		//Aado el Contenedor Inicial
		
		getPanelInicial();		
		
		//Coloco la Ventana
		
		setColocacion();
		
		
		//	ojo! que inicialmente la ventana esta oculta, en el main hay que hacerla visible
		//	esto es as para que no se vea como se van cargando y/o ocultando los elementos de la ventana
		
		this.setVisible(false); 									
	
	}
	
	private void setParametros(){
		
		this.setFont(new Font("Dialog", Font.PLAIN, 12));
		this.setBackground(SystemColor.inactiveCaptionText);
		this.setResizable(false);
		this.setName("CoolTran");
		this.setIconImage(Toolkit.getDefaultToolkit().getImage("imagenes/icono_app.png"));
		this.setTitle("CoolTran");
	}
	
	private void getPanelInicial(){
		panelInicial = new PanelInicial();
		this.setContentPane(panelInicial);
	}
	
	private void eventosSO(){
		

			//	Porque de momento el Iconificar solo funciona en windows
					
				if (Configuracion.propiedades.getProperty("SO").toLowerCase().contains("windows")){	
						this.setDefaultCloseOperation(JFrame.ICONIFIED);
					}else{
						this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
					}
	}
	
	
	private void setColocacion(){
		
		Dimension screenSize = null;
		
		screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		
		//	pone la ventana en la esquina inferior derecha
		this.setBounds( screenSize.width-324, screenSize.height-380-30, 324, 380); 
	}

	
	public void setClipboardHabilitado(boolean valor){
		booClipboard=valor;
	}
	
	public boolean getClipboardHabilitado(){
		return booClipboard;
	}
	
	
	public void configurarEventosVentana(final Aplicacion aplicacion){
		
			if (Configuracion.propiedades.getProperty("SO").toLowerCase().contains("windows")) {
				
				   this.addWindowListener(new java.awt.event.WindowAdapter() {    
					   public void windowActivated(java.awt.event.WindowEvent e) {
						   

							//Activamos la busqueda por clipboard			   
							if (getClipboardHabilitado()){
								
				        		Termino term =null;
				        		term = aplicacion.buscarTermino("",true);
								panelInicial.panelPestanas.pestana1.setTraduccion(term);							
								
								setClipboardHabilitado(false);
							}				
						}
					   
					   public void windowClosing(java.awt.event.WindowEvent e) {
							//Activamos la busqueda por clipboard
						   setClipboardHabilitado(true);
						   
						}
					   
				   });
				   
				}else{
					
					this.addWindowListener(new java.awt.event.WindowAdapter() {    
					   public void windowIconified(java.awt.event.WindowEvent e) {
							//Activamos la busqueda por clipboard
						   setClipboardHabilitado(true);			
						}
				    	public void windowDeiconified(java.awt.event.WindowEvent e) {	
					        if (getClipboardHabilitado() ){
					        		Termino term =null;
					        		term = aplicacion.buscarTermino("",true);
									panelInicial.panelPestanas.pestana1.setTraduccion(term);
																	 
					        }
						}
				    });
				
				}
			
			}
	
	public void cambiarColorInterfaz(){
		
		panelInicial.cambiarColorInterfaz();
	}
	
	public void cambiarIdiomaInterfaz(){
		
		panelInicial.cambiarIdiomaInterfaz();
	}
	


	
}  
